/*
 * File         : Participant.java
 * Author       : Tomasz Stachowiak
 * Created      : Wed Jun 18 17:45:22 1997
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

import java.sql.*;

class Participant {

  String id;
  String host;
  String name;
  String first_name;
  String type;

  NCSdatabase db;


  public Participant(NCSdatabase database) {

    db = database;
    type = "user";
  }

  public Participant(NCSdatabase database, String pid, String phost) {

    db = database;

    id = pid;
    host = phost;
    type = "user";
  }


  public void addName(String l, String f) {
    name = l;
    first_name = f;
  }

  public void add2db() {

    String sql = "INSERT INTO participant VALUES ('"
      +id+"','"+host+"','"+name+"','"
      +first_name+"','"+type+"')";

    db.updateSQL(sql);
  }
    
  public boolean isInDb() {
    
    String sql = "SELECT * FROM participant WHERE id='" 
                 +id+"' AND host='"+host+"'";
 
    try {
      ResultSet rs = db.querySQL(sql);

      if(!rs.next())
	return false;
      else
	return true;
    } catch (SQLException e) {
      
      System.out.println("Participant: " + e);
    }
    
    return true;            
  }
    
  public void join(Session ses) {

    if(!isInDb())
      add2db();

    String sql = "INSERT INTO participates VALUES ('"
      +id+"','"+host+"',"+ses.getID()+")";

    db.updateSQL(sql);
  }

  public void retrieve(ResultSet rs) {

    try {
      
      id = rs.getString("id");
      host = rs.getString("host");
      name = rs.getString("name");
      first_name = rs.getString("first_name");
      type = rs.getString("type");

    } catch (SQLException e) {

      System.out.println("Participant: " + e);
    }
  }

  public String toString() {

    return id + "@" + host;
  }
}
